////////////////////////////////////////////////////////////////////////
// sprite03.c
// Mochilote - www.cpcmania.com
////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Nick.h"

#define MAX_X 79
#define MAX_Y 199

void SetColor(unsigned char nColorIndex, unsigned char nPaletteIndex)
{
  __asm
    ld a, 4 (ix)
    ld b, 5 (ix)
    ld c, b
    call #0xBC32 ;SCR SET INK
    __endasm;
}

void SetPalette(const unsigned char *pPalette)
{
  unsigned char nColor = 0;

  for(nColor = 0; nColor < NUM_COLORS; nColor++)
    SetColor(nColor, pPalette[nColor]);
}

void PutSpriteMode0(unsigned char *pAddress, unsigned char nWidth, unsigned char nHeight, unsigned char *pSprite)
{
	__asm
		LD L, 4(IX) 
		LD H, 5(IX) 
		LD C, 6(IX) 
		LD B, 7(IX)            
		LD E, 8(IX) 
		LD D, 9(IX) 

		_loop_alto:
		   PUSH BC
		   LD B,C
		   PUSH HL
		_loop_ancho:
		   LD A,(DE)
		   LD (HL),A
		   INC DE
		   INC HL
		   DJNZ _loop_ancho
		   POP HL
		   LD A,H
		   ADD #0x08
		   LD H,A
		   SUB #0xC0
		   JP NC, _sig_linea
		   LD BC, #0xC050
		   ADD HL,BC
		_sig_linea:
		   POP BC
		   DJNZ _loop_alto
	__endasm;
}


////////////////////////////////////////////////////////////////////////
unsigned char char1,char2,char3,char4;

unsigned int GetTime()
{
	unsigned int nTime = 0;

	__asm
		CALL #0xBD0D ;KL TIME PLEASE
		PUSH HL
		POP DE
		LD HL, #_char3
		LD (HL), D
		LD HL, #_char4
		LD (HL), E
	__endasm;

	nTime = (char3 << 8) + char4;

	return nTime;
}
////////////////////////////////////////////////////////////////////////

void main()
{
	unsigned int nFPS = 0;
	unsigned int nTimeLast = 0;
	
	int nX = 40;
	int nY = 100;
	char nXDir = 1;
	char nYDir = 2;
	
	//SCR_SET_MODE 0
	__asm
		ld a, #0
		call #0xBC0E
	__endasm;

	//SCR SET BORDER 0
  __asm
    ld b, #0 ;black
    ld c, b
    call #0xBC38
  __endasm;
  
  SetPalette(NickPalette);
  
	nTimeLast = GetTime();

	while(1)
	{
		//move
		nX += nXDir;
		nY += nYDir;
		
		if(nX <= 0)
		{
			nX = 0;
			nXDir = 1;
		}

		if(nY <= 0)
		{
			nY = 0;
			nYDir = 2;
		}
		
		if(nX >= (MAX_X - NICK_WIDTH))
		{
			nX = MAX_X - NICK_WIDTH;
			nXDir = -1;
		}

		if(nY >= (MAX_Y - NICK_HEIGHT))
		{
			nY = MAX_Y - NICK_HEIGHT;
			nYDir = -2;
		}

		//paint
		PutSpriteMode0((unsigned char *)(0xC000 + ((nY / 8u) * 80u) + ((nY % 8u) * 2048u) + nX), NICK_WIDTH, NICK_HEIGHT, NickSprite);
		
		nFPS++;

		if(GetTime() - nTimeLast >= 300)
		{
			//TXT SET CURSOR 0,0
			__asm
				ld h, #1
				ld l, #1
				call #0xBB75
			__endasm;

			printf("%u  ", nFPS);

			nTimeLast = GetTime();
			nFPS = 0;
		}
	}
}
////////////////////////////////////////////////////////////////////////